const axios = require('axios');
const express = require('express');
const bodyParser = require('body-parser');

const ACCESS_TOKEN = process.env.ACCESS_TOKEN;

const VERIFY_TOKEN = '1qaz2wsx';

const server = express();

server.use(bodyParser.json());

server.get('/', (req, res) => {
  if (
    req.query['hub.mode'] === 'subscribe' &&
    req.query['hub.verify_token'] === VERIFY_TOKEN
  ) {
    res.send(req.query['hub.challenge']);
  } else {
    console.error('Failed validation. Make sure the validation tokens match.');
    res.sendStatus(403);
  }
});

// {
//   "entry": [
//     {
//       "changes": [
//         {
//           "field": "feed",
//           "value": {
//             "item": "status",
//             "sender_name": "逼歐梯測試",
//             "sender_id": 1895382890692545,
//             "post_id": "1895382890692545_2013573958873437",
//             "verb": "add",
//             "published": 1,
//             "created_time": 1505837069,
//             "message": "Test"
//           }
//         }
//       ],
//       "id": "1895382890692545",
//       "time": 1505837070
//     }
//   ],
//   "object": "page"
// }
// {
//   "entry": [
//     {
//       "changes": [
//         {
//           "field": "feed",
//           "value": {
//             "item": "comment",
//             "sender_name": "逼歐梯測試",
//             "comment_id": "2013573958873437_2013574035540096",
//             "sender_id": 1895382890692545,
//             "post_id": "1895382890692545_2013573958873437",
//             "verb": "add",
//             "parent_id": "1895382890692545_2013573958873437",
//             "created_time": 1505837091,
//             "message": "有嗎"
//           }
//         }
//       ],
//       "id": "1895382890692545",
//       "time": 1505837092
//     }
//   ],
//   "object": "page"
// }

server.post('/', (req, res) => {
  // console.log(JSON.stringify(req.body, null, 2));
  const change = req.body.entry[0].changes[0];

  console.log(change);

  if (
    change.field === 'feed' &&
    change.value.item === 'comment' &&
    change.value.verb === 'add'
  ) {
    const commentId = change.value.comment_id;

    axios
      .post(`https://graph.facebook.com/v2.10/${commentId}/private_replies`, {
        message: '收到了',
        access_token: ACCESS_TOKEN,
      })
      .then(console.log)
      .catch(err => console.log(err.response.data));
  }
  res.sendStatus(200);
});

module.exports = server;
