const { Bot } = require('toolbot-core-experiment');
const { createServer } = require('toolbot-core-experiment/koa');

const { FacebookConnector } = require('../src');

const ACCESS_TOKEN = process.env.ACCESS_TOKEN;
const VERIFY_TOKEN = '1qaz2wsx';
const POST_ID = '1895382890692545_2013573958873437';

const bot = new Bot({
  connector: new FacebookConnector({ accessToken: ACCESS_TOKEN }),
});

bot.onEvent(async context => {
  console.log(context.event.rawEvent);
  if (context.event.isCommentAdd && context.event.comment.post_id === POST_ID) {
    const commentId = context.event.rawEvent.value.comment_id;

    try {
      await context.client.sendPrivateReply(commentId, 'OK!');
    } catch (err) {
      console.log(err.response.data);
    }
  }
});

const server = createServer(bot, { verifyToken: VERIFY_TOKEN });

module.exports = server;
