const { MessengerEvent } = require('toolbot-core-experiment');

module.exports = class FacebookEvent extends MessengerEvent {
  get isConversation() {
    return this.rawEvent.field === 'conversation';
  }

  get isFeed() {
    return this.rawEvent.field === 'feed';
  }

  get isStatus() {
    return this.isFeed && this.rawEvent.value.item === 'status';
  }

  get isStatusAdd() {
    return this.isStatus && this.rawEvent.value.verb === 'add';
  }

  get isStatusRemove() {
    return this.isStatus && this.rawEvent.value.verb === 'remove';
  }

  get status() {
    return this.isStatus && this.rawEvent.value;
  }

  get isComment() {
    return this.isFeed && this.rawEvent.value.item === 'comment';
  }

  get isCommentAdd() {
    return this.isComment && this.rawEvent.value.verb === 'add';
  }

  get isCommentRemove() {
    return this.isComment && this.rawEvent.value.verb === 'remove';
  }

  get comment() {
    return this.isComment && this.rawEvent.value;
  }
};
